// maf_order.c -- order rows in a maf-file entries according to a given list
// args: maf-file species1 species2 .. [nohead] [all] [P=mapping-file]
// By default, only blocks with more than a single row are output; if "all"
// is specified, then even single-row blocks are output.

#include "util.h"
#include "maf.h"
#include "multi_util.h"

#define MAX_ENTRIES 100
#define VERSION 10

int main(int argc, char **argv) {
	struct mafFile *mf;
	struct mafAli *a;
	struct mafComp **location;
	char **species, buf[500];
	int i, nspecies, head = 1, all=0;
	//struct str_node *chrs=NULL, *spes=NULL, *chr, *spe;

	sprintf(buf, "maf_order.v%d", VERSION);
	argv0 = buf;

	if (argc < 3)
		fatal(" -- order rows according to a give list.\nargs: maf-file species1 species2 .. [nohead] [all]");
	/*
	if ( argv[argc-1][0]=='P' && argv[argc-1][1]=='=') {
	  fpr = fopen(argv[argc-1]+2, "r");
	  while ( fgets(buf, 500, fpr) != NULL) {
	    chr = (struct str_node*)malloc(sizeof(struct str_node));
	    spe = (struct str_node*)malloc(sizeof(struct str_node));
	    
	    if (sscanf(buf, "%s -> %s", char_array1, char_array2)!=2)
	      fatalf("mapping file entry in wrong format: %s", buf);
	    chr->str = copy_string(char_array1);
	    spe->str = copy_string(char_array2);
	    chr->next = chrs;
	    spe->next = spes;
	    chrs = chr;
	    spes = spe;
	  }	  
	  fclose(fpr);
	  argc--;
	}
	*/
	if ( same_string(argv[argc-1], "all")) {
	  all = 1;
	  --argc;
	}

	if (same_string(argv[argc-1], "nohead")) {
		head = 0;
		--argc;
	}
	
	mf = mafOpen(argv[1], 1);
	nspecies = argc - 2;
	species = ckalloc(nspecies*sizeof(char *));
	for (i = 0; i < nspecies; ++i)
	  species[i] = copy_string(argv[i+2]);
	if (head)
		mafWriteStart(stdout, "maf_project");
	location = ckalloc(nspecies*sizeof(struct mafComp *));
	while ((a = mafNext(mf)) != NULL) {
	  order_rows_species(&a, location, species, nspecies);
	  if ( a== NULL)
	    continue;
	  if ( a->components->next == NULL && all==0)  // single-row
	    continue;
	  a = mafColDashRm(a);
	  if ( a!=NULL) {
	    if ( a->components->strand == '-')
	      rc(a);
	    mafWrite(stdout, a);
	    mafAliFree(&a);
	  }
	}
	free(location);
	return 0;
}
